<?


/*
* @version $Id: nbepay_notify.php 617 2007-01-04 19:43:08Z soeren_nb $
* @package VirtueMart
* @subpackage Payment
*
* @copyright (C) 2004 Soeren Eberhardt
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
* VirtueMart is Free Software.
* VirtueMart comes with absolute no warranty.
*
* www.virtuemart.net
*/



if( !isset( $_REQUEST["orderid"] ) || empty( $_REQUEST["orderid"] ) ){
 
   echo "Order ID is not set or emtpy!";

   exit();
}

//-------------------------------------------------------------
      global $mosConfig_absolute_path, $mosConfig_live_site, $mosConfig_lang, $database,$mosConfig_mailfrom, $mosConfig_fromname;
    
        /*** access Joomla's configuration file ***/
        $my_path = dirname(__FILE__);


        if( file_exists($my_path."/../../../configuration.php")) {
            $absolute_path = dirname( $my_path."/../../../configuration.php" );
            require_once($my_path."/../../../configuration.php");
        }
        elseif( file_exists($my_path."/../../configuration.php")){
            $absolute_path = dirname( $my_path."/../../configuration.php" );
            require_once($my_path."/../../configuration.php");
        }
        elseif( file_exists($my_path."/configuration.php")){
            $absolute_path = dirname( $my_path."/configuration.php" );
            require_once( $my_path."/configuration.php" );
        }
        else {
            die( "Joomla Configuration File not found!" );
        }

 
        $absolute_path = realpath( $absolute_path );
        
        // Set up the appropriate CMS framework
        if( class_exists( 'jconfig' ) ) {
			define( '_JEXEC', 1 );
			define( 'JPATH_BASE', $absolute_path );
			define( 'DS', DIRECTORY_SEPARATOR );
			
			// Load the framework
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'defines.php' );
			require_once ( JPATH_BASE . DS . 'includes' . DS . 'framework.php' );

			// create the mainframe object
			$mainframe = & JFactory::getApplication( 'site' );
			
			// Initialize the framework
			$mainframe->initialise();
			
			// load system plugin group
			JPluginHelper::importPlugin( 'system' );
			
			// trigger the onBeforeStart events
			$mainframe->triggerEvent( 'onBeforeStart' );
			$lang =& JFactory::getLanguage();
			$mosConfig_lang = $GLOBALS['mosConfig_lang']          = strtolower( $lang->getBackwardLang() );
			// Adjust the live site path
			$mosConfig_live_site = str_replace('/administrator/components/com_virtuemart', '', JURI::base());
			$mosConfig_absolute_path = JPATH_BASE;
        } else {
        	define('_VALID_MOS', '1');
        	require_once($mosConfig_absolute_path. '/includes/joomla.php');
        	require_once($mosConfig_absolute_path. '/includes/database.php');
        	$database = new database( $mosConfig_host, $mosConfig_user, $mosConfig_password, $mosConfig_db, $mosConfig_dbprefix );
        	$mainframe = new mosMainFrame($database, 'com_virtuemart', $mosConfig_absolute_path );
        }

        // load Joomla Language File
        if (file_exists( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' )) {
            require_once( $mosConfig_absolute_path. '/language/'.$mosConfig_lang.'.php' );
        }
        elseif (file_exists( $mosConfig_absolute_path. '/language/english.php' )) {
            require_once( $mosConfig_absolute_path. '/language/english.php' );
        }
    /*** END of Joomla config ***/
    
    
    /*** VirtueMart part ***/        
        require_once($mosConfig_absolute_path.'/administrator/components/com_virtuemart/virtuemart.cfg.php');
        include_once( ADMINPATH.'/compat.joomla1.5.php' );
        require_once( ADMINPATH. 'global.php' );
        require_once( CLASSPATH. 'ps_main.php' );
        
        /* @MWM1: Logging enhancements (file logging & composite logger). */
        $vmLogIdentifier = "nbepay_notify.php";
        require_once(CLASSPATH."Log/LogInit.php");
   
//--------------------------------------------------------------
  require_once( CLASSPATH. 'payment/ps_nbepay.cfg.php' );


  $orderid  = $_REQUEST['orderid'];
  $appcode  = $_REQUEST['appcode'];
  $tranID   = $_REQUEST['tranID'];
  $domain   = $_REQUEST['domain'];
  $status   = $_REQUEST['status'];
  $amount   = $_REQUEST['amount'];
  $currency = $_REQUEST['currency'];
  $paydate  = $_REQUEST['paydate'];
  $channel  = $_REQUEST['channel']; 
  $skey     = $_REQUEST['skey'];

  $key0 = md5( $tranID.$orderid.$status.$domain.$amount.$currency );
  $key1 = md5( $paydate.$domain.$key0.$appcode.NBEPAY_SECRETWORD );
  //echo "<hr size=0>display<hr size=0>";

  $error_description="";

  //$status="11";

  if(  $status=="00" &&  $skey == $key1   ) ;
  else if(  $status=="00" &&  $skey != $key1   ) $error_description = "skey not match !"; 
  else if( $status=="11" )                  $error_description = "transaction failed.";
  else                                      $error_description = "invalid transaction.";

  $sendtoamin = NBEPAY_MERCHANT_EMAILTO;

  //-----------------------------------
  // payment success
  //-----------------------------------
  if(  $status=="00" &&  $skey == $key1   ){ 
        
       $payment_status =  $status;
       $order_id       =  trim(stripslashes($_REQUEST['orderid']));

       $d['order_id']     = $order_id; 
       $d['order_status'] = NBEPAY_VERIFIED_STATUS;           //  NBEPAY_VERIFIED_STATUS  , NBEPAY_INVALID_STATUS
       $d['order_comment']= "Payment Captured<br>Transaction ID: $tranID<br>Amount: $amount<br>App code: $appcode<br>Status: $status<br>channel: $channel<br>$paydate";

       require_once ( CLASSPATH . 'ps_order.php' );

       $ps_order= new ps_order;
       $ps_order->order_status_update($d);

       //-----------------------------------------
       if(  NBEPAY_MERCHANT_EMAIL == "True" && $sendtoamin!="" ){
           $mailsubject = "NBepay transaction on your site";
           $mailbody    = "Hello,\n\n";
           $mailbody   .= "a Nbepay transaction for you has been made on your website!\n";
           $mailbody   .= "-----------------------------------------------------------\n";
           $mailbody .= "Transaction ID: $tranID\n";
           //$mailbody .= "Payer Email: $payer_email\n";
           $mailbody .= "Order ID: $order_id\n";
           $mailbody .= "Amount: $amount\n";
           $mailbody .= "Payment Status returned by Nbepay: $payment_status\n";
           $mailbody .= "Order Status Code: Captured";
           vmMail( $mosConfig_mailfrom, $mosConfig_fromname,  $sendtoamin  , $mailsubject, $mailbody );
           //echo NBEPAY_MERCHANT_EMAIL;
        }
       //header("Location: http://joomla.netbuilder.biz/index.php?page=account.index&option=com_virtuemart&Itemid=1");
  }else {       
      //-----------------------------------
      // payment fail
      //-----------------------------------

       $payment_status =  $status;
       $order_id       =  trim(stripslashes($_REQUEST['orderid']));

       $d['order_id']     = $order_id; 
       $d['order_status'] = NBEPAY_INVALID_STATUS;           //  NBEPAY_VERIFIED_STATUS  , NBEPAY_INVALID_STATUS
       $d['order_comment']= "Payment Failed<br>Transaction ID: $tranID<br>Amount: $amount<br>App code: $appcode<br>Status: $status<br>channel: $channel<br>$paydate";

       require_once ( CLASSPATH . 'ps_order.php' );

       $ps_order= new ps_order;
       $ps_order->order_status_update($d);
       //-----------------------------------------
       if(  NBEPAY_MERCHANT_EMAIL == "True" && $sendtoamin!="" ){
           $mailsubject = "Invalid NBepay Transaction on your site";
           $mailbody = "Hello,\n\n";
           $mailbody .= "a Failed Nbepay Transaction requires your attention.\n";
           $mailbody .= "-----------------------------------------------------------\n";
           $mailbody .= "REMOTE IP ADDRESS: ".$_SERVER['REMOTE_ADDR']."\n";
           $mailbody .= "REMOTE HOST NAME: $remote_hostname\n";
           $mailbody .= "Order ID: ".$d['order_id']."\n";
           //$mailbody .= "User ID: ".$db->f("user_id")."\n";
           $mailbody .= "Payment Status returned by NBepay: $payment_status\n\n$error_description";
           vmMail( $mosConfig_mailfrom, $mosConfig_fromname,  $sendtoamin  , $mailsubject, $mailbody );
        }
  
  }
  //echo $error_description;
  //echo "end"; 
 //echo $d['order_status']."<hr size=0>".$status."<hr size=0>".NBEPAY_SECRETWORD;

  Header( SECUREURL."index.php?option=com_virtuemart&page=account.order_details&order_id=".$d['order_id']  ); 
 

?>
<script>
function gogo(){
  window.location.href="<?php echo SECUREURL."index.php?option=com_virtuemart&page=account.order_details&order_id=".$d['order_id'] ?>"; 
}
setTimeout("gogo()",1000);
</script>
